package com.kindlebook.hyrt.chapter16;

import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;

import android.os.Bundle;
import android.util.Log;
import android.widget.TextView;

public class QuizHelpActivity extends QuizActivity {
    public static final String DEBUG_TAG = "QuizHelpActivity";

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.help);

        InputStream helpFileStream = getResources().openRawResource(
                R.raw.quizhelp);
        try {
            TextView helpText = (TextView) findViewById(R.id.helpText);
            String strFile = inputStreamToString(helpFileStream);
            helpText.setText(strFile);
        } catch (IOException e) {
            Log.e(DEBUG_TAG, "Failed to read raw file.");
        }

    }

    public String inputStreamToString(InputStream is) throws IOException {
        StringBuffer sBuffer = new StringBuffer();
        DataInputStream dataIO = new DataInputStream(is);
        String strLine = null;
        while ((strLine = dataIO.readLine()) != null) {
            sBuffer.append(strLine + "\n");
        }

        dataIO.close();
        is.close();

        return sBuffer.toString();
    }

}