/**
 * 
 */
package com.kindlebook.hyrt.chapter16.test;

import android.content.Context;
import android.content.SharedPreferences;
import android.test.ActivityInstrumentationTestCase2;
import android.util.Log;
import android.widget.EditText;

import com.kindlebook.hyrt.chapter16.QuizActivity;
import com.kindlebook.hyrt.chapter16.QuizSettingsActivity;
import com.kindlebook.hyrt.chapter16.R;

/**
 * @author saconder
 * 
 */
public class QuizSettingsActivityTests extends
        ActivityInstrumentationTestCase2<QuizSettingsActivity> {
    private static final String DEBUG_TAG = "QuizSettingsActivityTests";
    private static final String TESTNICK_KEY_PRESSES = "T E S T N I C K ENTER";

    private EditText nickname;

    public QuizSettingsActivityTests() {
        super("com.kindlebook.hyrt.chapter15", QuizSettingsActivity.class);
    }

    /**
     * @throws java.lang.Exception
     */
    protected void setUp() throws Exception {
        super.setUp();
        final QuizSettingsActivity settingsActivity = getActivity();
        nickname = (EditText) settingsActivity.findViewById(R.id.nicknameEntry);

    }

    public void testNicknameFieldConsistency() {
        SharedPreferences settings = getActivity().getSharedPreferences(
                QuizActivity.GAME_PREFERENCES, Context.MODE_PRIVATE);
        String fromPrefs = settings.getString(
                QuizActivity.GAME_PREFERENCES_NICKNAME, "");
        String fromField = nickname.getText().toString();
        assertTrue("Field should equal prefs value",
                fromPrefs.equals(fromField));
    }

    public void testUpdateNickname() {
        Log.w(DEBUG_TAG, "Warning: "
                + "If nickname was previously 'testnick' this test is invalid.");
        getActivity().runOnUiThread(new Runnable() {
            public void run() {
                nickname.setText("");
                nickname.requestFocus();
            }
        });
        sendKeys(TESTNICK_KEY_PRESSES);
        ((QuizSettingsActivity) getActivity()).saveFormFields();
        SharedPreferences settings = getActivity().getSharedPreferences(
                QuizActivity.GAME_PREFERENCES, Context.MODE_PRIVATE);
        String fromPrefs = settings.getString(
                QuizActivity.GAME_PREFERENCES_NICKNAME, "");
        assertTrue("Prefs should be testnick",
                fromPrefs.equalsIgnoreCase("testnick"));
    }

}
