package com.kindlebook.hyrt.chapter8;

import android.content.Intent;
import android.content.res.TypedArray;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.TextView;

public class QuizMenuActivity extends QuizActivity {

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.menu);

        QuizMenuAdapter adapter = new QuizMenuAdapter(R.array.menu_items,
                R.array.menu_item_images);
        GridView menuList = (GridView) findViewById(R.id.gridView1);
        menuList.setAdapter(adapter);

        menuList.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View itemClicked,
                    int position, long id) {
                QuizMenuAdapter adapter = (QuizMenuAdapter) parent.getAdapter();
                Intent nextScreen = adapter.getItemIntent(position);
                if (nextScreen != null) {
                    startActivity(nextScreen);
                }
            }
        });
    }

    class QuizMenuAdapter extends BaseAdapter {
        private String[] itemStrings;
        private TypedArray itemIcons;

        public QuizMenuAdapter(int stringArrayId, int imageArrayId) {

            itemStrings = getResources().getStringArray(stringArrayId);
            itemIcons = getResources().obtainTypedArray(imageArrayId);
        }

        @Override
        public int getCount() {
            return itemStrings.length;
        }

        @Override
        public Object getItem(int position) {
            // NA
            return null;
        }

        @Override
        public long getItemId(int position) {
            // NA
            return 0;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            View itemView = convertView;
            if (convertView == null) {
                itemView = getLayoutInflater()
                        .inflate(R.layout.menu_item, null);
            }

            ImageView image = (ImageView) itemView
                    .findViewById(R.id.menuItemImage);
            TextView text = (TextView) itemView.findViewById(R.id.menuItemText);
            image.setImageDrawable(itemIcons.getDrawable(position));
            text.setText(itemStrings[position]);

            return itemView;
        }

        public Intent getItemIntent(int position) {
            Intent intent = null;
            switch (position) {
            case 0:
                intent = new Intent(QuizMenuActivity.this,
                        QuizGameActivity.class);
                break;
            case 1:
                intent = new Intent(QuizMenuActivity.this,
                        QuizScoresActivity.class);
                break;
            case 2:
                intent = new Intent(QuizMenuActivity.this,
                        QuizSettingsActivity.class);
                break;
            case 3:
                intent = new Intent(QuizMenuActivity.this,
                        QuizHelpActivity.class);
                break;
            }

            return intent;
        }
    }
}